#include <cstdio>
#include <string>
#include <algorithm>

char S[5][20];
int size;

long long  nwd(long long  a, long long b)	{
	if (b>a)
		return nwd(b,a);
	if(b==0)
		return a;
	return nwd(b,a%b);
};

#define rat long double
/*class rat {
public:
	long long l,m;
	rat() {
		l=-1;
		m=1;
	};
	friend bool operator< (const rat &A, const rat &B) {
		return A.l*B.m < B.l*A.m;
	};
	friend bool operator<= (const rat &A, const rat &B) {
		return A.l*B.m <= B.l*A.m;
	};
	friend void odejmij(const rat &A, const rat &B, rat &C) {
		C.m = A.m * B.m;
		C.l = A.l*B.m - A.m*B.l ;
		long long n = nwd(C.l,C.m);
		C.l /= n;
		C.m /= n;
	};
	void operator=(const rat &A) {
		l=A.l;
		m=A.m;
	};
	friend const rat & operator*(const rat &B, const rat &C) {
		static rat R;
		R.m = B.m*C.m;
		R.l = B.l*C.l;
		long long n = nwd(R.l,R.m);
		R.l /= n;
		R.m /= n;
		return R;
	};
};*/


rat P[5][5];
int small;

int dodaj(const char *s) {
	for(int i=0;i<size;i++)
		if (strcmp(s,S[i]) == 0)
			return i;
	strcpy(S[size++],s);
	return size-1;
};

class wzorzec {
public:
	int opisl;
	char opisj[20];
	rat dlug;
	void wylicz() {
		dlug = (long double)opisl * P[dodaj(opisj)][small].l;
		
	};
	friend bool operator<(const wzorzec &A, const wzorzec &B) {
		return A.dlug < B.dlug;
	};
};

wzorzec W[110000];
int wyszukaj(int p, int k, const wzorzec B) {
	if (p==k) return k;
	if (p==k-1) {
		static rat C,D;
		odejmij(B.dlug,W[p].dlug,C);
		odejmij(W[k].dlug,B.dlug,D);
		if (C <=  D)
			return p;
		else
			return k;
	};
	int s=(p+k)>>1;
	if (W[s].dlug < B.dlug)
		return wyszukaj(s,k,B);
	else
		return wyszukaj(p,s,B);
};


int main() {
	int D,d;
	scanf("%d",&D);
	for(d=0;d<D;d++) {
		for(int i=0;i<5;i++)
			for(int j=0;j<5;j++)
				P[i][j].l=-1;
		size=0;
		int p;
		scanf("%d",&p);
		char O1[20],O2[20];
		int o1,o2,x,y;
		for(int i=0;i<p;i++) {
			scanf("%d %s = %d %s",&y,O1,&x,O2);
			o1 = dodaj(O1);
			o2 = dodaj(O2);
			P[o1][o2] = x;
			P[o2][o1] = (long double)1/x;
		};
		for(int z=0;z<5;z++)
			for(int i=0;i<size;i++)
				for(int j=0;j<size;j++)
					for(int k=0;k<size;k++)
						if (P[i][j] > 0 && P[j][k] > 0)
							P[i][k] = P[i][j] * P[j][k];
		for(int i=0;i<5;i++) {
			P[i][i]=1;
		};
		small=0;
/*		for(int i=0;i<size;i++) {
			small=i;
			for(int j=0;j<size;j++)
				if (P[i][j].l > P[i][j].m)
					small=-1;
			if (small==i)
				break;
		};*/
		int w;
		scanf("%d",&w);
		for(int i=0;i<w;i++) {
			scanf("%d %s",&W[i].opisl,W[i].opisj);
			W[i].wylicz();
		};
		std::sort(W,W+w);
/*		printf("%d\n",small);
		for(int i=0;i<size;i++)
			printf("1 %s = %Ld/%Ld %s\n",S[i],P[i][small].l,P[i][small].m,S[small]);
		for(int i=0;i<w;i++)
			printf("%d %s = %Ld/%Ld %s\n",W[i].opisl,W[i].opisj,W[i].dlug.l,W[i].dlug.m,S[small]);*/
		int q;
		scanf("%d",&q);
		wzorzec Q;
		for(int i=0;i<q;i++) {
			scanf("%d %s",&Q.opisl,Q.opisj);
			Q.wylicz();
			int p = wyszukaj(0,w-1,Q);
			printf("%d %s\n",W[p].opisl,W[p].opisj);
		};
		
			
	};
	return 0;
};

