#include <cstdio>

#define MAXN 1000
#define MAXS 20000

int data[MAXN+1];
int sums[MAXN+1];
bool wins[MAXN+1][MAXS+1];

int D, N, S;

int main()
{
	scanf("%d",&D);
	for (int d=0; d<D; d++)
	{
		scanf("%d",&N);
		sums[0] = 0;
		for (int i=0; i<N; i++)
		{
			scanf("%d",&data[i]);
			sums[i+1] = data[i]+sums[i];
		}
		S = sums[N]/2;
		for (int j=0; j<=S; j++)
			wins[N][j] = false;
		for (int i=N-1; i>=0; i--)
			for (int j=0; j<=S; j++)
			{
				wins[i][j] = false;
				for (int k=i+1; k<i+5 && k<=N && (sums[k]-sums[i]+j)<=S; k++)
					if ((sums[k]-sums[i]+j)==S || (sums[i]-j)<0 || (sums[i]-j)>S || !wins[k][sums[i]-j])
					{
						wins[i][j] = true;
						break;
					}
			}
		if (wins[0][0])
			printf("TAK\n");
		else
			printf("NIE\n");
	}
	return 0;
}

