#include <cstdio>

long long  euklid(long long  a, long long  b, long long  &k, long long  &l) {
	long long  n,f,g,c,d;
	if (b>a) {
		return euklid(b,a,l,k);
	};
	if (b==0) {
		k=1;
		l=0;
		return a;
	};
	c=a/b;
	d=a%b;
	n=euklid(b,d,f,g);
	l=f-k*c;
	k=g;
	return n;
};

long long abs(long long a)
{
  if (a>=0) return a; else return -a;
}

void oneset()
{
 long long i,k[3],p[3],r[3],v[3],w[3],a[3],b[3],n[3],A[3],u[3],t[3],d,e,T1,x,q,NWW,aux,l,y;
  scanf("%lld",&k[0]);
  scanf("%lld",&k[1]);
  scanf("%lld",&k[2]);
  scanf("%lld",&p[0]);
  scanf("%lld",&p[1]);
  scanf("%lld",&p[2]);
  scanf("%lld",&v[0]);
  scanf("%lld",&v[1]);
  scanf("%lld",&v[2]);
  scanf("%lld",&r[0]);
  scanf("%lld",&r[1]);
  scanf("%lld",&r[2]);
  scanf("%lld",&w[0]);
  scanf("%lld",&w[1]);
  scanf("%lld",&w[2]);
  
  if (p[1]==r[1] && p[2] == r[2] && p[0] == r[0])
  {
    printf("TAK\n");
    return;
  }
  for(i=0; i<3; i++)
    a[i] = abs(v[i] - w[i]);
  for(i=0; i<3; i++)
    b[i] = p[i] - r[i];
  for(i=0; i<3; i++)
    n[i] = euklid(k[i],a[i],aux,aux);
  for(i=0; i<3; i++)
    A[i] = k[i]/n[i];
  for(i=0; i<3; i++)
    euklid(k[i]/n[i],a[i]/n[i],aux,u[i]);
  for(i=0; i<3; i++)
  {
    if (b[i] % n[i] != 0)
    {
      printf("NIE\n");
      return;
    }
    t[i] = u[i] * b[i] / n[i];
  }
  d = euklid(A[0], A[1], y, l);
  if ((t[1]-t[0]) % d != 0)
  {
    printf("NIE\n");
    return;
  }
  q = (t[1]-t[0]) / d;
  x = y*q;
  T1 = x*A[0] + t[0];  
  NWW = A[0]*A[1]/d;
  e = euklid(t[2],NWW,aux,aux);
  if ((T1 - t[2]) % d !=0)
  {
    printf("NIE\n");
    return;
  } 
  printf("TAK\n");
  return;
}

int main() 
{
  int N;
  scanf("%d",&N);
  for(int i=0; i<N; i++)
    oneset();
  return 0;
};
