#include <cstdio>

class punkt {
public:
	long long x,y;
};



long long ccw (const punkt &A, const punkt &B, const punkt &C) {
	long long x1=B.x-A.x, y1=B.y-A.y, x2=C.x-A.x, y2=C.y-A.y;
	return x1*y2-x2*y1;
};

inline long long abs(long long a) {
	return (long long)a*(long long)a;
};
long long odl(const punkt &A, const punkt &B) {
	return abs(A.x-B.x) + abs(A.y-B.y);
};


int N;
punkt *Z = new punkt[550000];

int f,t;
int *W = new int[1100000];

int inc(int i) {
	i++;
	if (i >=t)
		i=f;
	return i;
};
	
long long ccv(int a, int b, int c) {
	return ccw(Z[W[a]],Z[W[b]],Z[W[c]]);
};

void wypluczka() {
	f=550000;t=550001;
	W[f]=0;
	int m=0;
	while(m<N) {
		W[t++]=m;
		long long x = Z[m].x;
		while (m<N && Z[m].x==x)
			m++;
		W[--f]=m-1;
		while(ccv(t-3,t-2,t-1) < 0) {
			W[t-2]=W[t-1];
			t--;
		};
		while (ccv(f+2,f+1,f) > 0) {
			W[f+1]=W[f];
			f++;
		};
	};
};

inline long long dist(int a, int b) {
	return odl(Z[a],Z[b]);
};

long long max() {
	long long max=0;
	int b=550000,d=550000;
/*
	printf("%d %d\n",f,t);
	for(int i=f;i<t;i++) {
		printf("%d %d :",Z[W[i]].x,Z[W[i]].y);
		for(int j=f;j<t;j++)
			printf("%Ld ",dist(W[i],W[j]));
		printf("\n");
	};
*/

	for(int i=f;i<t;i++)
		if (dist(W[b],W[d])<dist(W[b],W[i]))
			d=i;
	max=dist(W[b],W[d]);
	b=inc(b);
	while (b!= 550000) {
		while (dist(W[b],W[inc(d)])>=dist(W[b],W[d]))
			d=inc(d);
		if (dist(W[b],W[d])>max)
			max = dist(W[b],W[d]);
		b=inc(b);
	};
	return max;
};


int main() {
	int D,d;
	scanf("%d",&D);
	for(d=0;d<D;d++) {
		scanf("%d",&N);
		for(int n=0;n<N;n++)
			scanf("%Ld %Ld",&Z[n].x,&Z[n].y);
		wypluczka();
		printf("%Ld\n",max());
	};
	return 0;
};
